package de.lmu.ifi.pms.cep;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Version {
	public static final String status = "development";
	public static final String major = "0";
	public static final String minor = "3";
	public static final String revision = "2";
	
	public static String full(){
		return major + "." + minor + "." + revision;
	}
	
	public static class Java{
		
		@SuppressWarnings("hiding")
		public static final int major;
		@SuppressWarnings("hiding")
		public static final int minor;
		
		static{
			int[] version = version();
			major = version[0];
			minor = version[1];
		}
		
		static int[] version(){
			Matcher versionMatcher = Pattern.compile("(\\d+)\\.(\\d+)(?:\\..+)?").matcher(System.getProperty("java.version"));
			versionMatcher.matches();
			return new int[]{Integer.valueOf(versionMatcher.group(1)), Integer.valueOf(versionMatcher.group(2))};
		}
		
		public static boolean javaVersionIsGreaterOrEqualThan(final int major, final int minor){
			return Java.major > major | (Java.major == major & Java.minor >= minor);
		}
		
		public static final boolean greaterOrEqual1dot6 = javaVersionIsGreaterOrEqualThan(1, 6);
		public static final boolean greaterOrEqual1dot7 = javaVersionIsGreaterOrEqualThan(1, 7);
	}

}
