package de.lmu.ifi.pms.cep.dura.compiler.antlr.utils;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;
import java.util.TreeSet;

import de.lmu.ifi.pms.development.UnimplementedMethodError;


public class TreeIterator implements Iterable<DuraTree>, Iterator<DuraTree> {

	DuraTree next = null;
	
	final LinkedList<DuraTree> nodes = new LinkedList<DuraTree>();
	final Set<Integer> typeFilter = new TreeSet<Integer>();
	
	public TreeIterator(DuraTree root, int... nodeTypes) {
		for (int type : nodeTypes) {
			typeFilter.add(type);
		}
		
		nodes.add(root);
		findNext();
	}
	
	@Override
	public Iterator<DuraTree> iterator() {
		return this;
	}

	@Override
	public boolean hasNext() {
		return next != null;
	}

	@Override
	public DuraTree next() {
		DuraTree result = next;

		if (! nodes.isEmpty())
			findNext();

		return result;
	}

	@Override
	public void remove() {
		throw new UnimplementedMethodError();
	}

	private void findNext() {
		DuraTree node = nodes.poll();
		
		for (int i=node.getChildCount()-1; i>=0; i--) {
			nodes.push(node.getChild(i));
		}
		
		if (typeFilter.contains(node.getType())) {
			next = node;
		} else if (! nodes.isEmpty()) {
			findNext();
		} else {
			next = null;
		}
	}
}
