package de.lmu.ifi.pms.cep.dura.compiler.exceptions;

import java.util.Map;

public class DuraUnknownAttributeException extends DuraUnspecificCompliationException {

	public DuraUnknownAttributeException(String msg) {
		super(msg);
	}

	
	/**
	 * Reverse engineers the attribute that has been specified by the user and
	 * adapts the error message accordingly.
	 */
	public String getMessage(Map<String, String> substituePrefix) {
		String result = getMessage();
		
		for (String prefix : substituePrefix.keySet()) {
			String substitute = substituePrefix.get(prefix);
			
			result = result.replace(substitute, prefix);
		}
		
		return result;
	}
}
