package de.lmu.ifi.pms.cep.event_mill.execution.scheduler;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;

import de.lmu.ifi.pms.cep.event_mill.configuration.DEFAULTS;
import de.lmu.ifi.pms.cep.event_mill.execution.engine.Engine;


public class BasicSchedulerFactory extends SchedulerFactory {
	
	final long delayInMillis;
	
	@Attribute(name="delay", required=false)
	Long getDelay(){
		return this.delayInMillis;
	}
	
	@Element(name="sequencer", required=false, type=QuerySequencer.class)
	final QuerySequencer querySequencer;
	
	/*FIXME activate on bug fix in XML framework
	public BasicSchedulerFactory() {
		this(null, null);
	}
	*/
	
	public BasicSchedulerFactory(final long delayInMillis, final QuerySequencer sequencer) {
		super();
		this.delayInMillis = delayInMillis;
		this.querySequencer = sequencer;
	}
	
	public BasicSchedulerFactory(@Attribute(name="delay", required=false) final Long delayInMillis, @Element(name="sequencer", required=false, type=QuerySequencer.class) final QuerySequencer sequencer) {
		this((delayInMillis == null ? DEFAULTS.BasicSchedulerDefaultDelay : delayInMillis.longValue()), (sequencer == null ? DEFAULTS.defaultSequencer : sequencer));
	}

	@Override
	public SchedulerThread make(final Engine engine) {
		return new BasicScheduler(engine, this.delayInMillis, this.querySequencer);
	}

}
