package de.lmu.ifi.pms.cep.event_mill.io;


public abstract class BufferedMessageSource<MessageType> extends MessageSource<MessageType>{
	
	
	public BufferedMessageSource(final Class<MessageType> type){
		super(type);
	}
	
	public abstract boolean nextBlock();

	public abstract boolean next();
	
	public abstract MessageType current();
	
	@Override
	public MessageType read() {
		if(!this.next()){
			this.nextBlock();
			this.next();
		}
		return this.current();
	}
	
	@Override
	public MessageType[] readBlock() {
		if(!this.next()){
			this.nextBlock();
			this.next();
		}
		java.util.ArrayList<MessageType> block = new java.util.ArrayList<MessageType>();
		do{
			block.add(this.current());
		} while(this.next());
		return block.toArray(this.newBlock(block.size()));
	}
	
}
