package de.lmu.ifi.pms.cep.event_mill.io;

import java.util.regex.Matcher;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.event_mill.execution.program.StreamBufferStore;
import de.lmu.ifi.pms.cep.event_mill.io.stream.StreamIOProvider;

public abstract class EngineIOProvider<StoreType extends StreamBufferStore<StoreType, ?>> extends StreamIOProvider{

	public final Class<StoreType> type;
	
	public EngineIOProvider(final Class<StoreType> type, @Attribute(name="iri") final String identifier) {
		super(identifier);
		this.type = type;
	}
	
	@Override
	public boolean accepts(final String identifier) {
		Matcher matcher = PATTERNS.programIdentifierPattern.matcher(identifier);
		if(matcher.matches()){
			String[] decomposedIdentifier = PATTERNS.programIdentifier(identifier);
			String streamBufferStoreIdentifier = decomposedIdentifier[0];
			return streamBufferStoreIdentifier.equals(this.identifier);
		}
		else{
			return false;
		}
	}
	
	@Override
	public EngineIO<StoreType> connect(final String identifier) {
		Matcher matcher = PATTERNS.programIdentifierPattern.matcher(identifier);
		if(matcher.matches()){
			String[] decomposedIdentifier = PATTERNS.programIdentifier(identifier);
			String streamBufferStoreIdentifier = decomposedIdentifier[0];
			String program_name = decomposedIdentifier[1];
			if(streamBufferStoreIdentifier.equals(this.identifier)){
				return this.connectEngine(program_name);
			}
			else{
				throw new IllegalArgumentException();
			}
		}
		else{
			throw new IllegalArgumentException();
		}
	}
	
	public abstract EngineIO<StoreType> connectEngine(String program_name);
	
}
