package de.lmu.ifi.pms.cep.event_mill.io.bus;

import org.simpleframework.xml.Element;

import de.lmu.ifi.pms.cep.event_mill.io.catalog.DataCatalogProvider;
import de.lmu.ifi.pms.cep.event_mill.io.format.MessageFormatProvider;

public class WrapperMessageBusProviderCollection<MessageType> extends MessageBusProviderCollection{
	
	@Element(name="catalog")
	protected final DataCatalogProvider dataCatalog;
	
	@Element(name="format")
	protected final MessageFormatProvider<MessageType> formatter;//needs bijective formatter
	
	@Element(name="buses")
	protected final MessageBusProviderCollection buses;
	
	@Element(name="iri-postfix")
	protected final String identifierPostFix;
	
	public WrapperMessageBusProviderCollection(@Element(name="catalog") final DataCatalogProvider dataCatalog
			, @Element(name="format") final MessageFormatProvider<MessageType> formatter
			, @Element(name="buses") final MessageBusProviderCollection buses
			, @Element(name="iri-postfix") final String identifierPostFix
		) {
		super();		
		this.dataCatalog = dataCatalog;
		this.formatter = formatter;
		this.buses = buses;
		this.identifierPostFix = identifierPostFix;
	}

	@Override
	public boolean contains(final String identifier) {
		return this.buses.contains(identifier);
	}
	
	@Override
	public MessageBusProvider create(final String identifier) {
		return new WrapperMessageBusProvider<MessageType>(identifier, this.dataCatalog, this.formatter, this.buses.get(identifier + ":" + this.identifierPostFix));
	}

}
