package de.lmu.ifi.pms.cep.event_mill.io.format;

import org.simpleframework.xml.Root;
import org.simpleframework.xml.core.Resolve;

import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;

@Root(name="parameter-formatter")
public class ParameterFormatter {
	
	public ParameterFormatter() {
		super();
	}	

	public String matchParameter(final String message, final int start, final int maxEnd, final BasicTypeID type){
		return message.substring(start, maxEnd);
	}

	public boolean parseBoolean(final String value){
		return Boolean.parseBoolean(value.trim());
	}

	public byte parseByte(final String value) {
		return Byte.parseByte(value.trim());
	}

	public short parseShort(final String value) {
		return Short.parseShort(value.trim());
	}

	public int parseInt(final String value) {
		return Integer.parseInt(value.trim());
	}

	public long parseLong(final String value) {
		return Long.parseLong(value.trim());
	}

	public long parseTimestamp(final String value) {
		return Long.parseLong(value.trim());
	}

	public long parseDuration(final String value) {
		return Long.parseLong(value.trim());
	}

	public long parseIdentifier(final String value) {
		return Long.parseLong(value.trim());
	}

	public float parseFloat(final String value) {
		return Float.parseFloat(value.trim());
	}

	public double parseDouble(final String value) {
		return Double.parseDouble(value.trim());
	}

	public String parseString(final String value) {
		return value.trim();
	}

	public String formatBoolean(final boolean value) {
		return String.valueOf(value);
	}

	public String formatByte(final byte value) {
		return String.valueOf(value);
	}

	public String formatShort(final short value) {
		return String.valueOf(value);
	}

	public String formatInt(final int value) {
		return String.valueOf(value);
	}


	public String formatLong(final long value) {
		return String.valueOf(value);
	}

	public String formatTimestamp(final long value) {
		return String.valueOf(value);
	}

	public String formatDuration(final long value) {
		return String.valueOf(value);
	}

	public String formatIdentifier(final long value) {
		return String.valueOf(value);
	}

	public String formatFloat(final float value) {
		return String.valueOf(value);
	}

	public String formatDouble(final double value) {
		return String.valueOf(value);
	}

	public String formatString(final String value) {
		return value;
	}
	
	@Resolve
	protected ParameterFormatter resolve(){
		return this;
	}
	
}
