package de.lmu.ifi.pms.cep.event_mill.io.stream;

import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.ElementListUnion;


import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;

public class ExplicitStreamIOProviderCollection extends StreamIOProviderCollection{
	
	public final FixedArrayNavigableMap<String, StreamIOProvider> streams;
	
	@ElementListUnion({
		@ElementList(entry="empty-stream", inline=true, type=EmptyStreamIOProvider.class, required=false, empty=false),
		@ElementList(entry="composite-stream", inline=true, type=ExplicitStreamIOProviderCollection.class, required=false, empty=false),
		@ElementList(entry="stream", inline=true, type=StreamIOProvider.class, required=false, empty=false)
	})
	protected java.util.ArrayList<StreamIOProvider> getStreams(){
		if(this.streams.size() > 0){
			return new java.util.ArrayList<StreamIOProvider>(this.streams.values().javaCollection());
		}
		else{
			return null;
		}
	}
	
	public ExplicitStreamIOProviderCollection(){
		this(new StreamIOProvider[0]);
	}
	
	public ExplicitStreamIOProviderCollection(final StreamIOProvider... streamProviders) {
		super();		
		String[] streamNames = new String[streamProviders.length];
		for(int stream = 0; stream < streamProviders.length; ++stream){
			streamNames[stream] = streamProviders[stream].identifier; 
		}
		
		this.streams = new FixedArrayNavigableMap<String, StreamIOProvider>(streamNames, streamProviders);
	}
	
	public ExplicitStreamIOProviderCollection(final Collection<StreamIOProvider> streamIOProviders) {
		this(streamIOProviders.javaCollection());
	}
	
	public ExplicitStreamIOProviderCollection(	@ElementListUnion({
		@ElementList(entry="stream", inline=true, required=false, empty=false)
	})final java.util.ArrayList<StreamIOProvider> streamIOProviders){
		this((java.util.Collection<StreamIOProvider>) streamIOProviders);
	}
	
	public ExplicitStreamIOProviderCollection(final java.util.Collection<StreamIOProvider> streamIOProviders) {
		this((streamIOProviders == null ? new StreamIOProvider[0] : streamIOProviders.toArray(new StreamIOProvider[streamIOProviders.size()])));
	}
	
	@Override
	public boolean contains(final String identifier){
		return this.streams.contains(identifier);
	}
	
	@Override
	public StreamIOProvider get(final String identifier){
		return this.streams.get(identifier);
	}

}
