package de.lmu.ifi.pms.cep.tsa.conditions;

import org.antlr.runtime.tree.Tree;

public enum BinaryComparissonOperatorID {
	
	LESS("<"){
		
		@Override
		public BinaryComparissonOperatorID mirrored() {
			return GREATER;
		}
		
	},

	LESS_EQUAL("<="){
		
		@Override
		public BinaryComparissonOperatorID mirrored() {
			return GREATER_EQUAL;
		}
		
	},
	
	EQUAL("="){
		
		@Override
		public BinaryComparissonOperatorID mirrored() {
			return EQUAL;
		}
		
	},
	
	GREATER_EQUAL(">="){
		
		@Override
		public BinaryComparissonOperatorID mirrored() {
			return LESS_EQUAL;
		}
		
	},
	
	GREATER(">"){
		
		@Override
		public BinaryComparissonOperatorID mirrored() {
			return LESS;
		}
		
	},
	
	NOT_EQUAL("!="){
		
		@Override
		public BinaryComparissonOperatorID mirrored() {
			return NOT_EQUAL;
		}
		
	};//FIXME inserted new operator, may need adaption on rewriting temporal relations
	
	private final String token;
	public abstract BinaryComparissonOperatorID mirrored();
	
	private BinaryComparissonOperatorID(final String token) {
		this.token = token;
	}
	
	public static BinaryComparissonOperatorID fromToken(final Tree token) {
		for (BinaryComparissonOperatorID op : values()) {
			if (op.token.equals(token.getText()))
				return op;
		}
		
		throw new IllegalArgumentException();
	}
	
	public static BinaryComparissonOperatorID fromString(final String name){
		for (BinaryComparissonOperatorID op : values()) {
			if (op.token.equals(name))
				return op;
		}
		
		throw new IllegalArgumentException();
	}
	
	@Override
	public String toString() {
		return this.token;
	}

}
