package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.Type;



public class CastFunction extends Function<Type> {
	
	CastFunction(@Element(name="type") final Type type, @ElementList(entry="term", inline=true, required=false, empty=false) final java.util.ArrayList<Term<?>> arguments) {
		super(FunctionID.CAST, FunctionID.CAST.name(), type, 1, 1, arguments.toArray(new Term<?>[arguments.size()]));
	}
	
	public CastFunction(final Type type, final Term<?> argument) {
		super(FunctionID.CAST, FunctionID.CAST.name(), type, 1, 1, new Term[]{argument});
	}
	
	@Override
	protected int minArity() {
		return 1;
	}
	
	@Override
	protected int maxArity() {
		return 1;
	}
	
	public Term<?> arg(){
		return this.arg(0);
	}

	@Override
	public CastFunction newTerm(final Term<?>... arguments) {
		return new CastFunction(this.type, arguments[1]);
	}
	
	@Override
	public String toString() {
		return super.toString() + " : " + this.type.toString();
	}
}
