package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;
import de.lmu.ifi.pms.java.math.Math;


public class IntValue extends BasicTypeValue {

	@Attribute(name="value")
	public final int value;
	
	public IntValue(@Attribute(name="value") final int value) {
		super(BasicTypeID.INT);
		this.value = value;
		if(value < Math.MinIntValue){
			throw new IllegalArgumentException("Value is too small.");
		}
	}
	
	@Override
	protected int compareValue(final Value<BasicType> value) {		
		return this.value - ((IntValue)value).value;
	}
	
	@Override
	protected int valueHashcode() {
		return this.value;
	}
	
	@Override
	public String toString() {
		return String.format("%d : %s", this.value, this.type.toString());
	}

}
