package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;
import de.lmu.ifi.pms.cep.tsa.schema.NoType;


public class Least<TypeClass extends AType> extends TupleFunction<TypeClass> {

	public Least(final TypeClass type, final Term<?>... arguments) {
		super(TupleFunctionID.LEAST, type, arguments);
	}
	
	@SuppressWarnings("unchecked")
	Least(@Element(name="type", required=false) final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		super(TupleFunctionID.LEAST, (type==null ? (TypeClass)NoType.instance : type), arguments);
	}
	
	@Override
	public Least<TypeClass> newTerm(final Term<?>... arguments) {
		return new Least<TypeClass>(this.type, arguments);
	}

}
