package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;


public class NamedConstant extends UntypedConstant {
	
	@Attribute(name="name")
	public final String name;

	public NamedConstant(final String name) {
		super();
		this.name = name;
	}
	
	public NamedConstant rename(final String newName){
		return new NamedConstant(newName);
	}
	
	@Override
	protected int compareToImpl(final Term<?> o) {
		int cmp = super.compareToImpl(o);
		if(cmp == 0){
			cmp = this.name.compareTo(((NamedConstant)o).name);
		}
		return cmp;
	}
	
	@Override
	protected boolean equalsImpl(final Object o) {
		if(this.getClass() == o.getClass()){
			return this.name.equals(((NamedConstant)o).name);
		}
		else{
			return false;
		}
	}
	
	@Override
	public int hashCode() {
		return super.hashCode() ^ this.name.hashCode();
	}
	
	@Override
	public String toString() {
		return String.format("const %s", this.name);
	}

}
