package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;


public class ReferenceValue extends BasicTypeValue {

	@Attribute(name="value")
	public final long value;
	
	public ReferenceValue(@Attribute(name="value") final long value) {
		super(BasicTypeID.REFERENCE);
		this.value = value;
	}
	
	@Override
	protected int compareValue(final Value<BasicType> value) {		
		return Long.signum(this.value - ((IntValue)value).value);
	}
	
	@Override
	protected int valueHashcode() {
		return (int)(this.value ^ (this.value >>> 32));
	}
	
	@Override
	public String toString() {
		return String.format("%d : %s", this.value, this.type.toString());
	}

}
