package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;

public class Sum<TypeClass extends AType> extends AggregationFunction<TypeClass> {

	public Sum(final TypeClass type, final Term<?> argument) {
		super(AggregationFunctionID.SUM, type, argument);
	}
	
	Sum(@Element(name="type") final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false) final java.util.ArrayList<Term<?>> arguments) {
		super(AggregationFunctionID.SUM, type, arguments);
	}
	
	@Override
	protected Sum<TypeClass> newTerm(final Term<?> argument) {
		return new Sum<TypeClass>(this.type, argument);
	}

}
