package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.Root;

import de.lmu.ifi.pms.cep.tsa.schema.AType;
import de.lmu.ifi.pms.cep.tsa.schema.NoType;


@Root(name="tuple")
public class Tuple<TypeClass extends AType> extends CompositeTerm<TypeClass> {
	
	@SuppressWarnings("unchecked")
	private Tuple(@Element(name="type", required=false) final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		super(TermID.TUPLE, (type == null ? (TypeClass)NoType.instance : type) , false, arguments.toArray(new Term<?>[arguments.size()]));
	}
	
	public Tuple(final TypeClass type, final Term<?>... arguments) {
		this(type, true, arguments);
	}
	
	protected Tuple(final TypeClass type, final boolean copy, final Term<?>... arguments) {
		super(TermID.TUPLE, type, copy, arguments);
	}
	
	@Override
	public Tuple<TypeClass> newTerm(final Term<?>... arguments){
		return new Tuple<TypeClass>(this.type, arguments);
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(")");
		if(this.argumentsArray.length > 0){
			for(int argument = 0; argument < this.argumentsArray.length; ++argument){
				sb.append(this.argumentsArray[argument]);
				sb.append(", ");
			}
			sb.setLength(sb.length() - ", ".length());
		}
		sb.append(")");
		return sb.toString();
	}
}
