package de.lmu.ifi.pms.cep.tsa.conditions;


public enum TupleFunctionID {

	PLUS(2,2,"plus"),
	
	MINUS(2,2,"minus"),
	
	TIMES(2,2,"times"),
	
	DIVISION(2,2,"div"),
	
	POWER(2,2,"power"),
	
	LEAST("least"),
	
	GREATEST("greatest"),
	
	USER("user");
	
	public final int minArity;
	
	public final int maxArity;
	
	public final String name;
	
	private TupleFunctionID(final String name){
		this(1,Integer.MAX_VALUE, name);
	}

	private TupleFunctionID(final int minArity, final int maxArity, final String name) {
		this.minArity = minArity;
		this.maxArity = maxArity;
		this.name = name;
	}
	
	@Override
	public String toString() {
		return this.name;
	}
}
