package de.lmu.ifi.pms.cep.tsa.conditions;

import de.lmu.ifi.pms.cep.tsa.schema.Type;

public abstract class TypedConstant<TypeClass extends Type> extends Constant<TypeClass> {

	public TypedConstant(final TypeClass type) {
		super(type);
	}
	
	@Override
	protected int compareToImpl(final Term<?> o) {
		int cmp = super.compareToImpl(o);
		if(cmp == 0){
			cmp = this.type.compareTo(((TypedConstant<?>)o).type);
		}
		return cmp;
	}
	
	@Override
	protected boolean equalsImpl(final Object o) {
		if(this.getClass().equals(o.getClass())){
			return this.type.equals(((TypedConstant<?>)o).type);
		}
		else{
			return false;
		}
	}
	
	@Override
	public int hashCode() {
		return super.hashCode() ^ this.type.hashCode();
	}
	
}
