package de.lmu.ifi.pms.cep.tsa.conditions;

import de.lmu.ifi.pms.cep.tsa.schema.Type;

public abstract class Value<TypeClass extends Type> extends TypedConstant<TypeClass> {

	public Value(final TypeClass type) {
		super(type);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	protected int compareToImpl(final Term<?> o) {
		int cmp = super.compareToImpl(o);
		if(cmp == 0){
			cmp = this.compareValue(((Value<TypeClass>)o));
		}
		return cmp;
	}
	
	@SuppressWarnings("unchecked")
	@Override
	protected boolean equalsImpl(final Object o) {
		if(super.equalsImpl(o)){
			return this.compareValue(((Value<TypeClass>)o)) == 0;
		}
		else{
			return false;
		}
	}
	
	@Override
	public int hashCode() {
		return super.hashCode() ^ this.valueHashcode();
	}
	
	protected abstract int compareValue(Value<TypeClass> value);
	
	protected abstract int valueHashcode();

}
