package de.lmu.ifi.pms.cep.tsa.conditions.analysis;

import de.lmu.ifi.pms.cep.tsa.conditions.AtomicConditionFormula;
import de.lmu.ifi.pms.java.util.adaption.Adapter;
import de.lmu.ifi.pms.java.util.collection.AbstractCollection;
import de.lmu.ifi.pms.java.util.filter.AbstractFilter;
import de.lmu.ifi.pms.java.util.filter.Filter;

public class PropositionalSimpleFocusedFormulaAnalyser extends SimpleFocusedFormulaAnalyser {
	
	public static final Filter<AtomicConditionFormula> focus = new AbstractFilter<AtomicConditionFormula>() {
			
			@Override
			public boolean accepts(final AtomicConditionFormula element) {
				return true;
			}
			
	};
	
	public static final Adapter<AtomicConditionFormula, AtomicConditionFormula> localType =
		new Adapter<AtomicConditionFormula, AtomicConditionFormula>(){
		
			@Override
			public AtomicConditionFormula adapt(final AtomicConditionFormula atom) {
				return atom;
			}
			
	};
				
	@Override
	public Adapter<AtomicConditionFormula, AtomicConditionFormula> localType() {
		return localType;
	}

	@Override
	public Filter<AtomicConditionFormula> postAdaptFocus() {
		return focus;
	}

	@Override
	public boolean isConsistent(final AbstractCollection<AtomicConditionFormula> positiveLiterals, final AbstractCollection<AtomicConditionFormula> negativeLiterals) {
		//FIXME more efficient implementation i.e. using compareTo and sorting
		for(AtomicConditionFormula positiveLiteral: positiveLiterals){
			for(AtomicConditionFormula negativeLiteral: negativeLiterals){
				if(positiveLiteral.equals(negativeLiteral)){
					return false;
				}
			}
		}
		return true;
	}

}
