package de.lmu.ifi.pms.cep.tsa.exceptions;

import de.lmu.ifi.pms.java.util.collection.fixed.FixedCollection;
import de.lmu.ifi.pms.java.util.collection.fixed.empty.Empty;

public class TSA_Exception extends Exception {
	
	public final FixedCollection<String> origin;

	protected TSA_Exception() {
		this(Empty.<String>instance());
	}

	protected TSA_Exception(final String message) {
		this(Empty.<String>instance(), message);

	}
	
	protected TSA_Exception(final String messageFormat, final Object... args) {
		this(String.format(messageFormat, args));
	}
	
	protected TSA_Exception(final Throwable cause) {
		this(cause.getMessage(), cause);
	}

	protected TSA_Exception(final TSA_Exception cause) {
		this(cause.origin, cause.getSimpleMessage(), cause);
	}

	protected TSA_Exception(final String message, final TSA_Exception cause) {
		this(Empty.<String>instance(), message, cause);
	}
	
	public TSA_Exception(final FixedCollection<String> origin) {
		super();
		this.origin = origin;
	}

	public TSA_Exception(final FixedCollection<String> origin, final String message) {
		super(message);
		this.origin = origin;
	}
	
	public TSA_Exception(final FixedCollection<String> origin, final String messageFormat, final Object... args) {
		this(origin, String.format(messageFormat, args));
	}
	
	public TSA_Exception(final FixedCollection<String> origin, final Throwable cause) {
		super(cause.getMessage(), cause);
		this.origin = origin;
	}

	public TSA_Exception(final FixedCollection<String> origin, final TSA_Exception cause) {
		super(cause.getSimpleMessage(), cause);
		this.origin = origin;
	}

	public TSA_Exception(final FixedCollection<String> origin, final String message, final TSA_Exception cause) {
		super(message, cause);
		this.origin = origin;
	}
	
	public String getSimpleMessage(){
		return super.getMessage();
	}
	
	public String getSimpleLocalizedMessage(){
		return super.getLocalizedMessage();
	}
	
	@Override
	public String getMessage() {
		String message = this.getSimpleMessage();
		if(message == null){
			message = "null";
		}
		StringBuilder sb = new StringBuilder(message);
		for(String o: this.origin){
			sb.append("\n");
			sb.append(o);
		}
		return sb.toString();
	}

}
