package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;
import java.util.NoSuchElementException;

public class BufferingIteratorWrapper<Type> extends AbstractBufferingIterator<Type> {
	
	private Type current;
	
	private final Iterator<Type> iterator;

	public BufferingIteratorWrapper(final Iterator<Type> iterator) {
		super();
		this.iterator = iterator;
	}

	@Override
	public final boolean hasNext() {
		return this.iterator.hasNext();
	}
	
	@Override
	public final boolean hasCurrent() {
		return this.current != null;
	}
	
	@Override
	public final Type current(){
		if(this.current == null){
			throw new NoSuchElementException(); //TODO better exception
		}
		else{
			return this.current;
		}
	}

	@Override
	public final Type next() {
		this.current = this.iterator.next();
		return this.current;
	}

}
