package de.lmu.ifi.pms.java.lang.iteration;

import java.util.ListIterator;


public class FinalListIteratorWrapper<Type> extends AbstractFinalListIterator<Type> {

	private final ListIterator<Type> iterator;	
	
	public FinalListIteratorWrapper(final ListIterator<Type> iterator) {
		super();
		this.iterator = iterator;
	}

	@Override
	public boolean hasNext() {
		return this.iterator.hasNext();
	}

	@Override
	public Type next() {
		return this.iterator.next();
	}

	@Override
	public boolean hasPrevious() {
		return this.iterator.hasPrevious();
	}

	@Override
	public int nextIndex() {
		return this.iterator.nextIndex();
	}

	@Override
	public Type previous() {
		return this.iterator.previous();
	}

	@Override
	public int previousIndex() {
		return this.iterator.previousIndex();
	}

}
