package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;
import java.util.NoSuchElementException;

import de.lmu.ifi.pms.java.util.adaption.IterationAdapter;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;



public class FinalVectorIterator<Type> extends AbstractIterator<FixedArray<Type>> {

	private final FixedArray<Iterator<Type>> iterators;

	public FinalVectorIterator(final FixedArray<Iterator<Type>> iterators) {
		super();
		this.iterators = iterators;
	}
	
	@Override
	public boolean hasNext() {
		for(final Iterator<Type> iterator: this.iterators){
			if(!iterator.hasNext()){
				return false;
			}
		}
		return true;
	}
	
	@Override
	public FixedArray<Type> next() {
		if(this.hasNext()){
			return new FixedArray<Type>(new IterationAdapter<Iterator<Type>, Type>(this.iterators){
				@Override
				public Type adapt(final Iterator<Type> iterator) {
					return iterator.next();
				}
			}, this.iterators.size());
		}
		else{
			throw new NoSuchElementException();//TODO better Exception
		}
	}
	
	@SuppressWarnings("deprecation")
	@Override
	public void remove() {
		for(final Iterator<Type> iterator: this.iterators){
			iterator.remove();
		}
	}
	
}
