package de.lmu.ifi.pms.java.util.adaption;

import de.lmu.ifi.pms.java.util.collection.array.Arrays;

public abstract class ArrayAdaptor<SourceType, DestinationType> implements Adapter<SourceType[], DestinationType[]>{
	
	protected final Class<DestinationType> destinationType;
	
	public ArrayAdaptor(final Class<DestinationType> destinationType) {
		super();
		this.destinationType = destinationType;
	}

	@Override
	public DestinationType[] adapt(final SourceType[] source){
		DestinationType[] destination = Arrays.getArray(this.destinationType, source.length);
		for(int index = 0; index < destination.length; ++index){
			destination[index] = this.map(source[index]);
		}
		return destination;
	}
	
	public abstract DestinationType map(final SourceType source);

}
