package de.lmu.ifi.pms.java.util.collection.composition;

import de.lmu.ifi.pms.java.lang.iteration.FixedComposedIterator;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.fixed.FixedCollection;

public class FixedComposedCollection<Type> extends ComposedCollection<Type, Collection<Type>> implements FixedCollection<Type>{

	@SuppressWarnings("unchecked")
	public FixedComposedCollection(final Collection<? extends Collection<? extends Type>> collections) {
		super((Collection<? extends Collection<Type>>)collections);
	}

	@SuppressWarnings("unchecked")
	public FixedComposedCollection(final Collection<? extends Type>... collections) {
		super((Collection<Type>[])collections);
	}

	@Override
	public FixedComposedIterator<Type> iterator() {
		return new FixedComposedIterator<Type>(this.collections, true);
	}

}
