package de.lmu.ifi.pms.java.util.collection.fixed.set;

import java.util.Comparator;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.util.collection.javaWrapper.ToJavaSortedSetWrapper;
import de.lmu.ifi.pms.java.util.collection.set.AbstractSortedSet.AbstractJavaSortedSet;



public abstract class AbstractFixedSortedSet<Type> extends AbstractFixedSet<Type>
		implements FixedSortedSet<Type> {

	@Override
	public abstract AbstractFixedIterator<Type> iterator();

	@Override
	public abstract int size();

	@Override
	public abstract Comparator<? super Type> comparator();

	@Override
	public abstract Type first();

	@Override
	public abstract FixedSortedSet<Type> headSet(Type toElement);

	@Override
	public abstract Type last();

	@Override
	public abstract FixedSortedSet<Type> subSet(Type fromElement, Type toElement);

	@Override
	public abstract FixedSortedSet<Type> tailSet(Type fromElement);
	
	@Override
	public AbstractJavaSortedSet<Type> javaCollection() {
		return new ToJavaSortedSetWrapper<Type>(this);
	}

}
