package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import java.util.Iterator;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.util.collection.fixed.AbstractFixedCollection;


public class FixedIterableWrapper<Type> extends AbstractFixedCollection<Type> {

	private final Iterable<Type> iteration;
	private final int elementCount;
	
	public FixedIterableWrapper(final Iterable<Type> iteration, final int elementCount) {
		super();
		this.iteration = iteration;
		this.elementCount = elementCount;
	}

	@Override
	public AbstractFixedIterator<Type> iterator() {
		final Iterator<Type> iterator = this.iteration.iterator();
		return new FiniteIteratorWrapper<Type>(iterator, this.elementCount);
	}

	@Override
	public int size() {
		return this.elementCount;
	}

}
