package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import java.util.Set;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.lang.iteration.FinalIteratorWrapper;
import de.lmu.ifi.pms.java.util.collection.fixed.set.AbstractFixedSet;



public class FixedSetWrapper<Type> extends AbstractFixedSet<Type> {
	
	private final Set<Type> collection;	
	
	public FixedSetWrapper(final Set<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public final AbstractFixedIterator<Type> iterator() {
		return new FinalIteratorWrapper<Type>(this.collection.iterator());
	}

	@Override
	public final int size() {
		return this.collection.size();
	}

}
