package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import java.util.Comparator;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.lang.iteration.FinalIteratorWrapper;
import de.lmu.ifi.pms.java.util.collection.fixed.set.AbstractFixedSortedSet;
import de.lmu.ifi.pms.java.util.collection.fixed.set.FixedSortedSet;


public class FixedSortedSetWrapper<Type> extends AbstractFixedSortedSet<Type>{
	
	private final java.util.SortedSet<Type> collection;	
	
	public FixedSortedSetWrapper(final java.util.SortedSet<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public final AbstractFixedIterator<Type> iterator() {
		return new FinalIteratorWrapper<Type>(this.collection.iterator());
	}

	@Override
	public final int size() {
		return this.collection.size();
	}


	@Override
	public Comparator<? super Type> comparator() {
		return this.collection.comparator();
	}

	@Override
	public final Type first() {
		return this.collection.first();
	}

	@Override
	public final FixedSortedSet<Type> headSet(final Type toElement) {
		return new FixedSortedSetWrapper<Type>(this.collection.headSet(toElement));
	}

	@Override
	public final Type last() {
		return this.collection.last();
	}

	@Override
	public final FixedSortedSet<Type> subSet(final Type fromElement, final Type toElement) {
		return new FixedSortedSetWrapper<Type>(this.collection.subSet(fromElement, toElement));
	}

	@Override
	public final FixedSortedSet<Type> tailSet(final Type fromElement) {
		return new FixedSortedSetWrapper<Type>(this.collection.tailSet(fromElement));
	}

}
