package de.lmu.ifi.pms.java.util.collection.set;

import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.array.ModifyableArray;
import de.lmu.ifi.pms.java.util.collection.compatibility.ArrayList;

public class NormalSet<Type> extends ArrayList<Type> {

	public NormalSet() {
		super();
	}
	
	public NormalSet(Set<Type> s){
		super(s);
	}

	public NormalSet(Collection<? extends Type> c) {
		super(eliminate(c));
	}

	public NormalSet(int initialCapacity) {
		super(initialCapacity);
	}

	public static <Type> Collection<Type> eliminate(Collection<Type> c){
		ModifyableArray<Type> l = new ModifyableArray<Type>(c.size(), Object.class);
		int i = 0;
		for(Type e: c){
			if(!l.contains(e)){
				l.set(i, e);
			}
			++i;
		}
		return l.subArray(0, i);
	}
	
	@Override
	public boolean add(Type e) {
		if(!contains(e)){
			super.add(e);
			return true;
		}
		else{
			return false;
		}
		//TODO exception
	}
	
	@Override
	public void set(int index, Type element) {
		if(!contains(element)){
			super.set(index, element);
		}
		//TODO exception
	}
	


}
