package de.lmu.ifi.pms.java.util.comparator;

import java.util.Iterator;

public abstract class AbstractAlphabethicIterableComparator<Type> extends AbstractComparator<Iterable<Type>> {

	public AbstractAlphabethicIterableComparator() {
		super();
	}

	@Override
	public int compare(Iterable<Type> o1, Iterable<Type> o2) {
		Iterator<Type> iterator1 = o1.iterator();
		Iterator<Type> iterator2 = o2.iterator();
		int compareResult = 0;
		while(iterator1.hasNext() && iterator2.hasNext() && compareResult == 0){
			compareResult = compareElements(iterator1.next(),iterator2.next());
		}
		if(compareResult == 0){
			if(iterator1.hasNext()){
				return -1;
			}
			else if(iterator2.hasNext()){
				return 1;
			}
			else{
				return 0;
			}
		}
		else{
			return compareResult;
		}
	}
	
	public abstract int compareElements(Type t1, Type t2);

}
