/**
 * 
 */
package de.lmu.ifi.pms.java.util.map;


/**
 * @author Simon Matthias Brodt
 *
 */
public abstract class AbstractEntry<KeyType, ValueType> implements Entry<KeyType, ValueType>{

	@Override
	public abstract KeyType key();
	
	@Override
	public abstract ValueType value();
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(final Object obj) {
		return this.keyEquals(((AbstractEntry<KeyType, ValueType>) obj).key());
	}
	
	protected boolean keyEquals(final KeyType key2){
		return this.key().equals(key2);
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		return this.key().hashCode();
	}
	
	@Override
	public java.util.Map.Entry<KeyType, ValueType> javaEntry() {
		return new java.util.AbstractMap.SimpleImmutableEntry<KeyType, ValueType>(this.key(), this.value());
	}
	
	@Override
	public String toString() {
		KeyType key = this.key();
		ValueType value = this.value();		
		return "( " + (key == null ? "null" : key.toString()) + " , " + (value == null ? "null" : value.toString()) + " )";
	}
	
}
