/**
 * 
 */
package de.lmu.ifi.pms.java.util.map;

import de.lmu.ifi.pms.java.lang.iteration.Iterator;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.set.SortedSet;
import de.lmu.ifi.pms.java.util.map.javaWrapper.ToJavaSortedMapWrapper;

/**
 * @author Simon Matthias Brodt
 *
 */
public abstract class AbstractSortedMap<KeyType, ValueType, EntryType extends Entry<KeyType, ValueType>>
	extends AbstractMap<KeyType, ValueType, EntryType>
	implements SortedMap<KeyType, ValueType, EntryType> {

	@Override
	public abstract SortedSet<KeyType> keys();

	@Override
	public abstract EntryType entry(KeyType key);

	@Override
	public abstract ValueType get(KeyType key);

	@Override
	public abstract boolean has(KeyType key);

	@Override
	public abstract Collection<ValueType> values();

	@Override
	public abstract Iterator<EntryType> iterator();

	@Override
	public abstract int size();

	@Override
	public abstract SortedMap<KeyType, ValueType, ?> headMap(KeyType toKey);

	@Override
	public abstract SortedMap<KeyType, ValueType, ?> tailMap(KeyType fromKey);
	
	@Override
	public AbstractJavaSortedMap<KeyType, ValueType> javaMap() {
		return new ToJavaSortedMapWrapper<KeyType, ValueType>(this);
	}
	
	public static abstract class AbstractJavaSortedMap<KeyType, ValueType> extends java.util.AbstractMap<KeyType, ValueType> implements java.util.SortedMap<KeyType, ValueType>{
		
	}

}
