package de.lmu.ifi.pms.java.util.map;

import de.lmu.ifi.pms.java.util.collection.set.NavigableSet;


public interface NavigableMap<KeyType, ValueType, EntryType extends Entry<KeyType, ValueType>> extends SortedMap<KeyType, ValueType, EntryType>{
	
	@Override
	public NavigableSet<KeyType> keys();
	
	public Entry<KeyType, ValueType> lowerEntry(KeyType key);

	public Entry<KeyType, ValueType> ceilingEntry(KeyType key);

	public Entry<KeyType, ValueType> higherEntry(KeyType key);

	public Entry<KeyType, ValueType> floorEntry(KeyType key);

	@Deprecated
	public NavigableSet<KeyType> descendingKeySet();
	
	public NavigableMap<KeyType, ValueType, ?> descendingMap();
	
	public KeyType floorKey(KeyType key);
	
	@Override
	public NavigableMap<KeyType, ValueType, ?> headMap(KeyType toKey);
	
	public NavigableMap<KeyType, ValueType, ?> headMap(KeyType toKey, boolean inclusive);
	
	public NavigableMap<KeyType, ValueType, ?> tailMap(KeyType fromKey, boolean inclusive);
	
	@Override
	public NavigableMap<KeyType, ValueType, ?> tailMap(KeyType fromKey);
	
	@Override
	public NavigableMap<KeyType, ValueType, ?> subMap(KeyType fromKey, KeyType toKey);
	
	public NavigableMap<KeyType, ValueType, ?> subMap(KeyType fromKey, boolean fromInclusive, KeyType toKey, boolean toInclusive);
	
	public Entry<KeyType, ValueType> firstEntry();
	
	public Entry<KeyType, ValueType> lastEntry();
	
	@Deprecated
	public NavigableSet<KeyType> navigableKeySet();
	
	@Override
	public java.util.NavigableMap<KeyType, ValueType> javaMap();
	
}
