package de.lmu.ifi.pms.java.util.map.compatibility;

import java.util.Comparator;

import de.lmu.ifi.pms.java.util.adaption.Adapter;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.map.Map;
import de.lmu.ifi.pms.java.util.map.SortedMap;
import de.lmu.ifi.pms.java.util.map.javaWrapper.FromJavaNavigableMapExtendibleWrapper;


public class TreeMap<KeyType, ValueType> extends FromJavaNavigableMapExtendibleWrapper<KeyType, ValueType>{

	public TreeMap() {
		super(new java.util.TreeMap<KeyType, ValueType>());
	}
	
	public TreeMap(final Comparator<? super KeyType> comparator) {
		super(new java.util.TreeMap<KeyType, ValueType>(comparator));
	}
	
	public TreeMap(final Map<? extends KeyType, ? extends ValueType, ?> map) {
		super(new java.util.TreeMap<KeyType, ValueType>(map.javaMap()));
	}
	
	public TreeMap(final java.util.Map<? extends KeyType, ? extends ValueType> map) {
		super(new java.util.TreeMap<KeyType, ValueType>(map));
	}
	
	public TreeMap(final SortedMap<? extends KeyType, ? extends ValueType, ?> map) {
		super(new java.util.TreeMap<KeyType, ValueType>(map.javaMap()));
	}
	
	public TreeMap(final java.util.SortedMap<? extends KeyType, ? extends ValueType> map) {
		super(new java.util.TreeMap<KeyType, ValueType>(map));
	}
	
	public TreeMap(final Adapter<ValueType, KeyType> indexer, final Collection<ValueType> values){
		this();
		for(ValueType value: values){
			this.add(indexer.adapt(value), value);
		}
	}

}
