package de.lmu.ifi.pms.java.util.map.javaWrapper;

import java.util.Comparator;

import de.lmu.ifi.pms.development.UnimplementedMethodError;
import de.lmu.ifi.pms.java.util.adaption.SetAdapter;
import de.lmu.ifi.pms.java.util.map.NavigableMap;
import de.lmu.ifi.pms.java.util.map.AbstractNavigableMap.AbstractJavaNavigableMap;


public class ToJavaNavigableMapWrapper<KeyType, ValueType> extends AbstractJavaNavigableMap<KeyType, ValueType> {
	
	final NavigableMap<KeyType, ValueType, ? extends de.lmu.ifi.pms.java.util.map.Entry<KeyType,ValueType>> map;
	
	public ToJavaNavigableMapWrapper(final NavigableMap<KeyType, ValueType, ? extends de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType>> map) {
		super();
		this.map = map;
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean containsKey(final Object key) {
		return this.map.has((KeyType)key);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public ValueType get(final Object key) {
		return this.map.get((KeyType)key);
	}
	
	@Override
	public java.util.Set<KeyType> keySet() {
		return this.map.keys().javaCollection();
	}
	
	@Override
	public int size() {
		return this.map.size();
	}
	
	@Override
	public java.util.Collection<ValueType> values() {
		return this.map.values().javaCollection();
	}
	
	@Override
	public String toString() {
		return this.map.toString();
	}

	@Override
	public java.util.Set<java.util.Map.Entry<KeyType, ValueType>> entrySet() {
		return new SetAdapter<de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType>,java.util.Map.Entry<KeyType, ValueType>>(this.map) {
			@Override
			public java.util.Map.Entry<KeyType, ValueType> adapt(final de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType> source) {
				return new SimpleEntry<KeyType, ValueType>(source.key(), source.value());
			}
		}.javaCollection();
	}

	@Override
	public Comparator<? super KeyType> comparator() {
		return this.map.comparator();
	}

	@Override
	public java.util.NavigableMap<KeyType, ValueType> subMap(final KeyType fromKey, final KeyType toKey) {
		return this.map.subMap(fromKey, toKey).javaMap();
	}

	@Override
	public java.util.NavigableMap<KeyType, ValueType> headMap(final KeyType toKey) {
		return this.map.headMap(toKey).javaMap();
	}

	@Override
	public java.util.NavigableMap<KeyType, ValueType> tailMap(final KeyType fromKey) {
		return this.map.tailMap(fromKey).javaMap();
	}

	@Override
	public KeyType firstKey() {
		return this.map.keys().first();
	}

	@Override
	public KeyType lastKey() {
		return this.map.keys().last();
	}

	@Override
	public java.util.Map.Entry<KeyType, ValueType> lowerEntry(final KeyType key) {
		return this.map.lowerEntry(key).javaEntry();
	}

	@Override
	public KeyType lowerKey(final KeyType key) {
		return this.map.keys().lower(key);
	}

	@Override
	public java.util.Map.Entry<KeyType, ValueType> floorEntry(final KeyType key) {
		return this.map.floorEntry(key).javaEntry();
	}

	@Override
	public KeyType floorKey(final KeyType key) {
		return this.map.keys().floor(key);
	}

	@Override
	public java.util.Map.Entry<KeyType, ValueType> ceilingEntry(final KeyType key) {
		return this.map.ceilingEntry(key).javaEntry();
	}

	@Override
	public KeyType ceilingKey(final KeyType key) {
		return this.map.keys().ceiling(key);
	}

	@Override
	public java.util.Map.Entry<KeyType, ValueType> higherEntry(final KeyType key) {
		return this.map.higherEntry(key).javaEntry();
	}

	@Override
	public KeyType higherKey(final KeyType key) {
		return this.map.keys().higher(key);
	}

	@Override
	public java.util.Map.Entry<KeyType, ValueType> firstEntry() {
		return this.map.firstEntry().javaEntry();
	}

	@Override
	public java.util.Map.Entry<KeyType, ValueType> lastEntry() {
		return this.map.lastEntry().javaEntry();
	}

	@Override
	public java.util.NavigableMap<KeyType, ValueType> descendingMap() {
		return this.map.descendingMap().javaMap();
	}

	@Override
	public java.util.NavigableSet<KeyType> navigableKeySet() {
		return this.map.keys().javaCollection();
	}

	@Override
	public java.util.NavigableSet<KeyType> descendingKeySet() {
		return this.map.keys().descendingSet().javaCollection();
	}

	@Override
	public java.util.NavigableMap<KeyType, ValueType> subMap(final KeyType fromKey, final boolean fromInclusive, final KeyType toKey, final boolean toInclusive) {
		return this.map.subMap(fromKey, fromInclusive, toKey, toInclusive).javaMap();
	}

	@Override
	public java.util.NavigableMap<KeyType, ValueType> headMap(final KeyType toKey, final boolean inclusive) {
		return this.map.headMap(toKey, inclusive).javaMap();
	}

	@Override
	public java.util.NavigableMap<KeyType, ValueType> tailMap(final KeyType fromKey, final boolean inclusive) {
		return this.map.tailMap(fromKey, inclusive).javaMap();
	}

	@Override
	public java.util.Map.Entry<KeyType, ValueType> pollFirstEntry() {
		//FIXME implement
		throw new UnimplementedMethodError();
	}

	@Override
	public java.util.Map.Entry<KeyType, ValueType> pollLastEntry() {
		//FIXME implement
		throw new UnimplementedMethodError();
	}
	
	

}
