package de.lmu.ifi.pms.java.util.map.javaWrapper;

import java.util.Comparator;

import de.lmu.ifi.pms.java.util.adaption.SetAdapter;
import de.lmu.ifi.pms.java.util.map.SortedMap;
import de.lmu.ifi.pms.java.util.map.AbstractSortedMap.AbstractJavaSortedMap;


public class ToJavaSortedMapWrapper<KeyType, ValueType> extends AbstractJavaSortedMap<KeyType, ValueType> {
	
	final SortedMap<KeyType, ValueType, ? extends de.lmu.ifi.pms.java.util.map.Entry<KeyType,ValueType>> map;
	
	public ToJavaSortedMapWrapper(final SortedMap<KeyType, ValueType, ? extends de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType>> map) {
		super();
		this.map = map;
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean containsKey(final Object key) {
		return this.map.has((KeyType)key);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public ValueType get(final Object key) {
		return this.map.get((KeyType)key);
	}
	
	@Override
	public java.util.Set<KeyType> keySet() {
		return this.map.keys().javaCollection();
	}
	
	@Override
	public int size() {
		return this.map.size();
	}
	
	@Override
	public java.util.Collection<ValueType> values() {
		return this.map.values().javaCollection();
	}
	
	@Override
	public String toString() {
		return this.map.toString();
	}

	@Override
	public java.util.Set<java.util.Map.Entry<KeyType, ValueType>> entrySet() {
		return new SetAdapter<de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType>,java.util.Map.Entry<KeyType, ValueType>>(this.map) {
			@Override
			public java.util.Map.Entry<KeyType, ValueType> adapt(final de.lmu.ifi.pms.java.util.map.Entry<KeyType, ValueType> source) {
				return new SimpleEntry<KeyType, ValueType>(source.key(), source.value());
			}
		}.javaCollection();
	}

	@Override
	public Comparator<? super KeyType> comparator() {
		return this.map.comparator();
	}

	@Override
	public java.util.SortedMap<KeyType, ValueType> subMap(final KeyType fromKey, final KeyType toKey) {
		return this.map.subMap(fromKey, toKey).javaMap();
	}

	@Override
	public java.util.SortedMap<KeyType, ValueType> headMap(final KeyType toKey) {
		return this.map.headMap(toKey).javaMap();
	}

	@Override
	public java.util.SortedMap<KeyType, ValueType> tailMap(final KeyType fromKey) {
		return this.map.tailMap(fromKey).javaMap();
	}

	@Override
	public KeyType firstKey() {
		return this.map.keys().first();
	}

	@Override
	public KeyType lastKey() {
		return this.map.keys().last();
	}
	
	

}
