package de.lmu.ifi.pms.java.util.stream.io;

import java.io.Closeable;

import de.lmu.ifi.pms.java.util.tupel.Single;



public class LocalObjectInputStream<Type> extends ObjectInputStream<Type,Single<Closeable,BlockingPipe<Type>>> {

	private final BlockingPipe<Type> pipe;
	
	public LocalObjectInputStream(final BlockingPipe<Type> pipe) {
		super();
		this.pipe = pipe;
	}
	
	@Override
	public Object closeLock() {
		return this.pipe;
	}
	
	@Override
	public Single<Closeable,BlockingPipe<Type>> resources() {
		return new Single<Closeable,BlockingPipe<Type>>(this.pipe);
	}

	@Override
	public Type readObject(){
		return this.pipe.readNext();
	}
	
	@Override
	public boolean hasObject() {
		return this.pipe.hasNext();
	}

}
